install-nix-action/lib/install-nix.sh

87 lines
2.5 KiB
Bash
Raw Normal View History

2020-02-26 13:12:17 +00:00
#!/usr/bin/env bash
set -euo pipefail
if type -p nix &>/dev/null ; then
echo "Aborting: Nix is already installed at $(type -p nix)"
exit
fi
# Create a temporary workdir
workdir=$(mktemp -d)
trap 'rm -rf "$workdir"' EXIT
2020-08-25 16:26:01 +00:00
# Configure Nix
add_config() {
echo "$1" | tee -a "$workdir/nix.conf" >/dev/null
2020-08-25 16:26:01 +00:00
}
2020-05-26 12:34:45 +00:00
# Set jobs to number of cores
2020-08-25 16:26:01 +00:00
add_config "max-jobs = auto"
# Allow binary caches for user
add_config "trusted-users = root $USER"
2020-08-25 16:13:35 +00:00
# Append extra nix configuration if provided
2020-08-25 16:56:36 +00:00
if [[ $INPUT_EXTRA_NIX_CONFIG != "" ]]; then
2020-08-25 16:26:01 +00:00
add_config "$INPUT_EXTRA_NIX_CONFIG"
fi
if [[ ! $INPUT_EXTRA_NIX_CONFIG =~ "experimental-features" ]]; then
add_config "experimental-features = nix-command flakes"
fi
2020-08-25 16:26:01 +00:00
# Nix installer flags
installer_options=(
--no-channel-add
--darwin-use-unencrypted-nix-store-volume
--nix-extra-conf-file "$workdir/nix.conf"
)
# only use the nix-daemon settings if on darwin (which get ignored) or systemd is supported
if [[ $OSTYPE =~ darwin || -e /run/systemd/system ]]; then
installer_options+=(
--daemon
2021-11-17 22:02:06 +00:00
--daemon-user-count "$(python -c 'import multiprocessing as mp; print(mp.cpu_count() * 2)')"
)
else
# "fix" the following error when running nix*
# error: the group 'nixbld' specified in 'build-users-group' does not exist
add_config "build-users-group ="
sudo mkdir -p /etc/nix
sudo chmod 0755 /etc/nix
2021-11-18 02:14:02 +00:00
cp $workdir/nix.conf /etc/nix/nix.conf
fi
2021-02-20 21:46:57 +00:00
if [[ $INPUT_INSTALL_OPTIONS != "" ]]; then
2021-11-17 22:02:06 +00:00
IFS=' ' read -r -a extra_installer_options <<< "$INPUT_INSTALL_OPTIONS"
2021-02-21 14:00:04 +00:00
installer_options=("${extra_installer_options[@]}" "${installer_options[@]}")
2021-02-20 21:46:57 +00:00
fi
2020-02-26 13:12:17 +00:00
2021-11-17 22:02:06 +00:00
echo "installer options: ${installer_options[*]}"
2021-11-01 18:04:45 +00:00
# There is --retry-on-errors, but only newer curl versions support that
curl_retries=5
while ! curl -sS -o "$workdir/install" -v --fail -L "${INPUT_INSTALL_URL:-https://nixos.org/nix/install}"
2021-11-01 18:04:45 +00:00
do
sleep 1
((curl_retries--))
if [[ $curl_retries -le 0 ]]; then
echo "curl retries failed" >&2
exit 1
fi
2021-11-01 18:04:45 +00:00
done
sh "$workdir/install" "${installer_options[@]}"
2020-05-27 11:17:01 +00:00
2020-02-26 13:12:17 +00:00
if [[ $OSTYPE =~ darwin ]]; then
2020-05-26 12:34:45 +00:00
# macOS needs certificates hints
2020-02-26 13:12:17 +00:00
cert_file=/nix/var/nix/profiles/default/etc/ssl/certs/ca-bundle.crt
echo "NIX_SSL_CERT_FILE=$cert_file" >> "$GITHUB_ENV"
2020-02-26 13:12:17 +00:00
export NIX_SSL_CERT_FILE=$cert_file
sudo launchctl setenv NIX_SSL_CERT_FILE "$cert_file"
fi
# Set paths
echo "/nix/var/nix/profiles/per-user/$USER/profile/bin" >> "$GITHUB_PATH"
echo "/nix/var/nix/profiles/default/bin" >> "$GITHUB_PATH"
2020-05-28 14:25:05 +00:00
2020-08-25 16:56:36 +00:00
if [[ $INPUT_NIX_PATH != "" ]]; then
echo "NIX_PATH=${INPUT_NIX_PATH}" >> "$GITHUB_ENV"
2020-05-28 14:25:05 +00:00
fi